#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <libgen.h>
#include <errno.h>
#include <sys/socket.h>
#include <linux/un.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>

#include "criu/criu-plugin.h"
#include "criu/criu-log.h"

#define BUF_LEN 256
#define DEST_SIZE 40

const char * utc_date() {
     char *buf = malloc(BUF_LEN);
     time_t rawtime = time(NULL);
     if (rawtime == -1) {
         puts("The time() function failed");
         return NULL;
     }
     struct tm *ptm = localtime(&rawtime);
     if (ptm == NULL) {
         puts("The localtime() function failed");
         return NULL;
     }
     strftime(buf, BUF_LEN, "%Y-%m-%d", ptm);
     puts(buf);
     return buf;
     }

void log_dumper(int stage, int ret) {
     const char* current_date = utc_date();
     char dest[DEST_SIZE] = "/var/spool/abrt-criu/criu-";
     strcat(dest, current_date);
     if (ret) {
        setenv("DUMP_DIR", dest, 0);
        pr_info("migration failed, running log collector\n");
        pr_info("Dump directory %s logs\n", getenv("DUMP_DIR"));
        int component = system("/usr/libexec/component_maker");

        if(component == -1){
            // The system method failed
            pr_info("failed to extract component info\n");
        }

        int rep_status = system("/usr/bin/reporter-vz-prlrep");
        if(rep_status == -1){
            // The system method failed
            pr_info("failed to running log collector\n");
        }
	}
}

CR_PLUGIN_REGISTER("logdumper", cr_plugin_dummy_init, log_dumper)
